/*
   This program parses and evaluates strings from Language_1.
*/

public class Language_1_Examples
{
   public static void main(String[] args)
   {
      String[] programs =
      {
         "( if true 0 1 )",

         "( if ( == 0 1 ) ( + 3 -5 ) ( ^ 2 5 ) )",

         "( prog " +
             "( var b true ) " +
             "( if b ( var x -1 ) ( var x 1 ) ) )",

         "( prog " +
             "( var i -5 ) " +
             "( if ( >= i 0 ) " +
                 "( print i ) " +
                 "( print ( - i ) ) ) )",

         "( prog " +
             "( var i 5 ) " +
             "( while ( > i 0 ) " +
                 "( print i ) " +
                 "( set i ( - i 1 ) ) ) )",

         "( prog " +
             "( var i 5 ) " +
             "( while ( > i 0 ) " +
                 "( print ( set i ( - i 1 ) ) ) ) )",

         "( prog " +
             "( var i -5 ) " +
             "( if ( >= i 0 ) " +
                "( while ( > i 0 ) " +
                    "( print i ) " +
                    "( set i ( - i 1 ) ) ) " +
                "( while ( < i 0 ) " +
                    "( print i ) " +
                    "( set i ( + i 1 ) ) ) ) )",

         "( prog " +
            "( var n 1 ) " +
            "( var sum 0 ) " +
            "( while ( < n 5 ) " +
                "( set sum ( + sum n ) ) " +
                "( set n ( + n 1 ) ) " +
                "( print n ) " +
                "( print sum ) ) " +
            "sum )",
      };


      int i = 0;
      for (i = 0; i < programs.length; i++)
      {
         System.out.println(i + " =============================================");

         try // to parse the program.
         {
            // Build the abstract syntax tree that represents the program.
            Tree ast = Parse.parse( programs[i] );
          //Tree ast = BuildTree.buildTree( programs[i] );

            // Pretty-print the abstract syntax tree.
            System.out.println( PrettyPrinter.prettyPrint( ast ) + "\n" );

            // Print the infix version of the program.
            System.out.println( AST2infix.ast2infix( ast ) + "\n" );

            try // to evaluate the program (interpret the AST).
            {
               Value value = Evaluate.eval( ast );
               System.out.println( "result = " + value + "\n" );
            }
            catch (EvalException e)
            {
             //System.out.println(e);
               e.printStackTrace();
            }

            if(true)
            try // to create dot and png files from the AST.
            {
               // Create the (empty) dot file.
               String baseName = String.format("Language_1.%02d", i);
               java.io.PrintWriter out = new java.io.PrintWriter(
                                            new java.io.File(baseName + ".dot") );
               // Put dot commands into the dot file
               out.println( Tree2dot.tree2dot(ast) + "\n" );
               out.close();
               // Create a command line for running dot.exe.
               String[] cmd = {"C:\\graphviz-2.38\\release\\bin\\dot.exe",
                               "-Tpng",
                               baseName + ".dot",
                               "-o",
                               baseName + ".png"};
               // Execute the command line.
               java.lang.Runtime.getRuntime().exec(cmd);
            }
            catch (Exception e)
            {
               System.out.println( e );
             //e.printStackTrace();
            }
         }
         catch (ParseException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
      }
   }//main()

}//Language_1_Examples
